/* Copyright (c) 1997-2004
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ident "$Project: polymake $$Id: is_ball_or_sphere.cc,v 1.12 2004/10/26 18:57:01 gawrilow Exp $"

#include <Poly.h>
#include <Array.h>
#include <complex_tools.h>

#include <string>

namespace polymake {
namespace topaz {
  
void is_ball_or_sphere(Poly& p)
{
   const Array< Set<int> > C = p.give("FACETS");
   int d; 
   p.give("DIM") >> d;
   
   bool is_BOS = true;
   if (d>2)
      throw std::runtime_error("is_ball_or_sphere: Dimension of the complex must be smaller 3.");
   
   if (d==0)
      is_BOS = C.size()<3;
   
   else if (d==1)
      is_BOS = C1_is_BOS(C);
   
   else if (d==2)
      is_BOS = C2_is_BOS(C);
   
   p.take("BALL_OR_SPHERE") << is_BOS;
}

} }

using namespace polymake;

/** @file is_ball_or_sphere
 *
 *  Check whether a complex is a ball or sphere.
 *  The client works for manifolds of dim 2 or smaller only.
 *
 *  @synopsis is_ball_or_sphere <file>
 *
 *  @reading  FACETS, DIM
 *  @writing  BALL_OR_SPHERE
 */

int main(int argc, const char* argv[])
{
   if (argc!=2) {
      cerr << "usage: " << argv[0] << " <file>" << endl;
      return 1;
   }
   try {
      Poly p(argv[1], ios::in | ios::out);
      topaz::is_ball_or_sphere(p);
   }
   catch (const std::exception& e) {
      cerr << e.what() << endl;
      return 1;
   }
   return 0;
}


// Local Variables:
// mode:C++
// c-basic-offset:3
// End:
